<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>

    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css">
</head>

<body>
    <div class="container m-5">
        <button type="button" class="btn btn-primary m-2" onclick="getAllPosts()">Get All</button>
        <button type="button" class="btn btn-secondary m-2" onclick="getPostById()">Get Detail</button>
        <button type="button" class="btn btn-success m-2" onclick="createPost()">Create</button>
        <button type="button" class="btn btn-danger m-2" onclick="updatePost()">Update</button>
        <button type="button" class="btn btn-warning m-2" onclick="deletePost()">Delete</button>

        <button type="button" class="btn btn-warning m-2" onclick="getData()">Get data 1 to 2</button>
    </div>

    <script>
        const gURL = "https://jsonplaceholder.typicode.com/posts";

        async function fetchAPI(url, options) {
            var response = await fetch(url, options);

            var data = await response.json();

            console.log(data);
        }

        function getAllPosts() {
            fetchAPI(gURL, {
                method: "GET"
            })
        }

        function getPostById() {
            fetchAPI(gURL + "/1", {
                method: "GET"
            });
        }

        function createPost() {
            fetchAPI(gURL, {
                method: 'POST',
                headers: {
                    'Content-type': 'application/json; charset=UTF-8',
                },
                body: JSON.stringify({
                    title: 'foo',
                    body: 'bar',
                    userId: 1,
                })
            })
        }

        function updatePost() {
            fetchAPI(gURL + "/1", {
                method: 'PUT',
                headers: {
                    'Content-type': 'application/json; charset=UTF-8',
                },
                body: JSON.stringify({
                    title: 'foo',
                    body: 'bar',
                    userId: 1,
                })
            })
        }

        function deletePost() {
            fetchAPI(gURL + "/1", {
                method: 'DELETE'
            })
        }

        async function getData() {
            try {
                var response1 = await fetch(gURL + "/1");

                var data1 = await response1.json();

                console.log(data1);

                var response2 = await fetch(gURL + "/2");

                var data2 = await response2.json();

                console.log(data2);
            } catch (error) {
                console.log(error);
            }  
        }

    </script>
</body>

</html>
